<?php 
$done = '&done=0';
$errors = array();
$button_caption = __('Save');

if (isset($_POST['submited'])) { # bouton Enregistrer
	# Vrif des spcs, dfauts, test des changements
  $dc_podcast_feed_title = (empty($_POST['dc_podcast_feed_title'.$feed_suffix])) ? dc_blog_name : podcast::encode_str($_POST['dc_podcast_feed_title'.$feed_suffix]);
  $dc_podcast_feed_editor = (empty($_POST['dc_podcast_feed_editor'.$feed_suffix])) ? podcast::format_editor('') : podcast::format_editor($_POST['dc_podcast_feed_editor'.$feed_suffix]);
  # suppression HTML et coupure  255 ou 4000 
  # if the line ends by cr, lf, cr-lf, lf-cr -> DC_PODCAST_CR (#CR;) pour tenir sur une ligne de conf.ini
  $dc_podcast_itunes_subtitle = (empty($_POST['dc_podcast_itunes_subtitle'.$feed_suffix])) ? dc_blog_name :
  	podcast::take( strip_tags($_POST['dc_podcast_itunes_subtitle'.$feed_suffix]), 255);
  $dc_podcast_itunes_subtitle = trim( preg_replace("/(\r\n|\n\r|\n|\r)/", DC_PODCAST_CR, $dc_podcast_itunes_subtitle), DC_PODCAST_CR);
	$dc_podcast_itunes_summary = podcast::take( strip_tags($_POST['dc_podcast_itunes_summary'.$feed_suffix]), 4000);
  $dc_podcast_itunes_summary = trim( preg_replace("/(\r\n|\n\r|\n|\r)/", DC_PODCAST_CR, $dc_podcast_itunes_summary), DC_PODCAST_CR);

  if ( ($dc_podcast_feed_ttl = (integer)$_POST['dc_podcast_feed_ttl'.$feed_suffix]) == 0 )
  	$dc_podcast_feed_ttl = 1440;
	$dc_podcast_feed_license = ( substr($_POST['dc_podcast_feed_license'.$feed_suffix], 0, strlen(DC_PODCAST_CCL)) == DC_PODCAST_CCL) ? $_POST['dc_podcast_feed_license'.$feed_suffix] : '';
	$dc_podcast_item_license = ( substr($_POST['dc_podcast_item_license'.$feed_suffix], 0, strlen(DC_PODCAST_CCL)) == DC_PODCAST_CCL) ? $_POST['dc_podcast_item_license'.$feed_suffix] : '';
  podcast::testSpecChange( array(
    'dc_podcast_rss_2_0_feed_path',
    'dc_podcast_feed_title',
    'dc_podcast_feed_post',
    'dc_podcast_feed_lang',
    'dc_podcast_feed_editor',
    'dc_podcast_channel_pubdate',
    'dc_podcast_feed_category',
    'dc_podcast_feed_copyr',
    'dc_podcast_item_license',
    'dc_podcast_feed_image',
    'dc_podcast_feed_ttl')
    );
	podcast::testSpecChange( array(
	'dc_podcast_itunes_subtitle',
  'dc_podcast_itunes_summary',
  'dc_podcast_feed_cat_itun',
  'dc_podcast_feed_cat1_itun',
  'dc_podcast_feed_cat2_itun',
  'dc_podcast_itunes_explicit',
  'dc_podcast_itunes_image',
  'dc_podcast_itunes_new_feed',
  'dc_podcast_item_author',
  'dc_podcast_feed_license',
  'dc_podcast_itunes_keywords')
  );

  # Ecriture des spcifications du fil RSS
  podcast::processSpec('dc_podcast_rss_2_0_feed_path', trim($_POST['dc_podcast_rss_2_0_feed_path'.$feed_suffix]));
  podcast::processSpec('dc_podcast_feed_title', $dc_podcast_feed_title);
  podcast::processSpec('dc_podcast_feed_post', trim($_POST['dc_podcast_feed_post'.$feed_suffix]));
  podcast::processSpec('dc_podcast_feed_lang', trim($_POST['dc_podcast_feed_lang'.$feed_suffix]));
  podcast::processSpec('dc_podcast_feed_editor', $dc_podcast_feed_editor);
  podcast::processSpec('dc_podcast_channel_pubdate', podcast::encode_str($_POST['dc_podcast_channel_pubdate'.$feed_suffix]));
  podcast::processSpec('dc_podcast_feed_category', podcast::encode_str($_POST['dc_podcast_feed_category'.$feed_suffix]));
  podcast::processSpec('dc_podcast_feed_copyr', podcast::encode_str($_POST['dc_podcast_feed_copyr'.$feed_suffix]));
  podcast::processSpec('dc_podcast_item_license', $dc_podcast_item_license);
  podcast::processSpec('dc_podcast_feed_image', trim($_POST['dc_podcast_feed_image'.$feed_suffix]));
  podcast::processSpec('dc_podcast_feed_ttl', $dc_podcast_feed_ttl);
  
  podcast::processSpec('dc_podcast_itunes_subtitle', podcast::encode_str($dc_podcast_itunes_subtitle));
  podcast::processSpec('dc_podcast_itunes_summary', podcast::encode_str($dc_podcast_itunes_summary));
  podcast::processSpec('dc_podcast_feed_cat_itun', podcast::encode_str($_POST['dc_podcast_feed_cat_itun'.$feed_suffix]));
  podcast::processSpec('dc_podcast_feed_cat1_itun', podcast::encode_str($_POST['dc_podcast_feed_cat1_itun'.$feed_suffix]));
  podcast::processSpec('dc_podcast_feed_cat2_itun', podcast::encode_str($_POST['dc_podcast_feed_cat2_itun'.$feed_suffix]));
  podcast::processSpec('dc_podcast_itunes_explicit', trim($_POST['dc_podcast_itunes_explicit'.$feed_suffix]));
  podcast::processSpec('dc_podcast_itunes_image', trim($_POST['dc_podcast_itunes_image'.$feed_suffix]));
  podcast::processSpec('dc_podcast_itunes_new_feed', trim($_POST['dc_podcast_itunes_new_feed'.$feed_suffix]));
  podcast::processSpec('dc_podcast_item_author', podcast::encode_str($_POST['dc_podcast_item_author'.$feed_suffix]));
  podcast::processSpec('dc_podcast_feed_license', $dc_podcast_feed_license);
  podcast::processSpec('dc_podcast_itunes_keywords', podcast::encode_str($_POST['dc_podcast_itunes_keywords'.$feed_suffix]));

  if ( podcast::saveConf() OR (count($errors) == 0) ) {
  	$done = '&done=1';
  	#	 il faut recharger la page pour actualiser les constantes
  	header('Location: ' . $plugin_url . '&mode=conf&feed_suffix='.$feed_suffix.$done); # Envoi d'un en-tte HTTP
  	exit;
  } else {
  	$errors[] = __('An error occured while writing the file.');
  }
}
# fin d'criture du conf.ini *******************************************

podcast::DisplayErrors($errors); # affichage des erreurs

# Affichage du formulaire
$itunes_msg = ''; $itunes_img = '';

$mySubMenu->addItem(
'<strong>'.__('Back to list').'</strong>',$plugin_url,'images/ico_retour.png',false);
$mySubMenu->addItem(
'<strong>'.__('Back to config').'</strong>','tools.php?p='.$dc_podcast_plugin_name.'&mode=conf','images/ico_retour.png',false);

if ( $feed_suffix == $feed_keys[0] ) {
	$value = 'gnral';
} else {
	$value = 'spcifique';
}
buffer::str('<h2>Spcifications du fil de syndication RSS2'.' '.$value.' - <em>'.$feed_names[$feed_suffix].'</em></h2>');

if ( (isset($_GET['done'])) && ($_GET['done'] == '1') )
	buffer::str('<p class="message">'.__('Configuration file successfully updated.').'</p>');

# function field($id,$size,$max,$default='',$tabindex='',$html='')
  
buffer::str(
'<form action="' . $plugin_url.'&mode=conf&feed_suffix='.$feed_suffix.$done . '" method="post">'.

'<fieldset>'.
'<legend>'.__('Channel specifications for').' <em>'.$feed_names[$feed_suffix].'</em></legend>'.
	
	'<p class="field"><label for="dc_podcast_rss_2_0_feed_path" class="float"><strong>'.
	__('RSS feeds directory').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_rss_2_0_feed_path').'</label>'.
	form::field('dc_podcast_rss_2_0_feed_path'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_rss_2_0_feed_path')).'</p>'.

	'<p class="field"><label for="dc_podcast_feed_title" class="float"><strong> '.
	__('Title').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_feed_title').'</label>'.
	form::field('dc_podcast_feed_title'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_feed_title')).'</p>'.
  
    '<p class="field"><label for="dc_podcast_itunes_subtitle" class="float"><strong>'.
  __('Description').'&nbsp;:</strong> '.
  helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_itunes_subtitle').'</label>'.
  form::textArea('dc_podcast_itunes_subtitle'.$feed_suffix, 67, 3, str_replace(DC_PODCAST_CR,"\r",podcast::specValue('dc_podcast_itunes_subtitle'))).'</p>'.

	'<p class="field"><label for="dc_podcast_feed_post" class="float"><strong>'.
	__('URL post').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_feed_post').'</label>'.
	form::field('dc_podcast_feed_post'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_feed_post')).'</p>'.
	
	'<p class="field"><label for="dc_podcast_feed_lang" class="float"><strong>'.
	__('Podcast language').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_feed_lang').'</label>'.
	form::field('dc_podcast_feed_lang'.$feed_suffix, 5, 5, podcast::specValue('dc_podcast_feed_lang')).'</p>'.

	'<p class="field"><label for="dc_podcast_feed_editor" class="float"><strong>'.
	__('Podcast editor').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_feed_editor').'</label>'.
	form::field('dc_podcast_feed_editor'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_feed_editor')).'</p>'.
      
  '<p class="field"><label for="dc_podcast_channel_pubdate" class="float"><strong>'.
	__('Publication date').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_channel_pubdate').'</label>'.
	form::field('dc_podcast_channel_pubdate'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_channel_pubdate')).'</p>'.

	'<p class="field"><label for="dc_podcast_feed_category" class="float"><strong>'.
	__('RSS feeds categories').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_feed_category').'</label>'.
	form::field('dc_podcast_feed_category'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_feed_category')).'</p>'.
  
	'<p class="field"><label for="dc_podcast_feed_copyr" class="float"><strong>'.
	__('Copyright').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_feed_copyr').'</label>'.
	form::field('dc_podcast_feed_copyr'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_feed_copyr')).'</p>'.

	'<p class="field"><label for="dc_podcast_feed_license" class="float"><strong>'.
	__('Podcast license').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_feed_license').'</label>'.
	form::combo('dc_podcast_feed_license'.$feed_suffix, podcast::CreativeCommonsLicenses(), podcast::specValue('dc_podcast_feed_license')).'</p>'.

	'<p class="field"><label for="dc_podcast_feed_image" class="float"><strong>'.
	__('Podcast image').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_feed_image').'</label>'.
	form::field('dc_podcast_feed_image'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_feed_image')).'</p>'.
  
  '<p class="field"><label for="dc_podcast_feed_ttl" class="float"><strong>'.
	__('Time to live').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_feed_ttl').'</label>'.
	form::field('dc_podcast_feed_ttl'.$feed_suffix, 5, 5, podcast::specValue('dc_podcast_feed_ttl')).'</p>'.
	
'</fieldset>');

# section iTunes specifics
if (constant('dc_podcast_itunes_image'.$feed_suffix) == '') { # preview default
	$itunes_img = '<p><img src="'.util::getHost().dc_app_url.'/'.
  	DC_ECRIRE.'/tools/'.$dc_podcast_plugin_name.'/iTunesDefaultImage.jpg" width="170" height="170" alt="Podcast iTunes Image" /></p>';
} else { # preview image found
	$itunes_img = '<p><img src="'.podcast::url_of(podcast::specValue('dc_podcast_itunes_image')).
  	'" width="170" height="170" alt="Podcast iTunes Image" /></p>';
}
buffer::str(
'<fieldset>'.
'<legend>'.__('Channel specifications for').' <em>'.$feed_names[$feed_suffix].'</em> - '.__('iTunes specific').__($itunes_msg).'</legend>'.
	  
  '<p class="field"><label for="dc_podcast_itunes_summary" class="float"><strong>'.
  __('Informations').'&nbsp;:</strong> '.
  helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_itunes_summary').'</label>'.
  form::textArea('dc_podcast_itunes_summary'.$feed_suffix, 67, 5, str_replace(DC_PODCAST_CR,"\r",podcast::specValue('dc_podcast_itunes_summary'))).'</p>'.
  
	'<p class="field"><label for="dc_podcast_feed_cat_itun" class="float"><strong>'.
  __('Category') . ' ' . __('subcategory').'&nbsp;:</strong> '.
  helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_feed_cat_itun').'</label>'.
  form::combo('dc_podcast_feed_cat_itun'.$feed_suffix, podcast::iTunesCategoryOptions(), podcast::specValue('dc_podcast_feed_cat_itun')).'</p>'.

	'<p class="field"><label for="dc_podcast_feed_cat_itun" class="float"><strong>'.
  __('Category') . ' ' . __('subcategory').'&nbsp;:</strong> '.
  helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_feed_cat_itun').'</label>'.
  form::combo('dc_podcast_feed_cat1_itun'.$feed_suffix, podcast::iTunesCategoryOptions(), podcast::specValue('dc_podcast_feed_cat1_itun')).'</p>'.

	'<p class="field"><label for="dc_podcast_feed_cat_itun" class="float"><strong>'.
  __('Category') . ' ' . __('subcategory').'&nbsp;:</strong> '.
  helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_feed_cat_itun').'</label>'.
  form::combo('dc_podcast_feed_cat2_itun'.$feed_suffix, podcast::iTunesCategoryOptions(), podcast::specValue('dc_podcast_feed_cat2_itun')).'</p>'.
      
  '<p class="field"><label for="explicit" class="float"><strong>'.
  __('Explicit').'&nbsp;:</strong> '.
  helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field explicit').'</label>'.
  form::combo('dc_podcast_itunes_explicit'.$feed_suffix,array(__('Yes')=>'yes',__('No')=>'no','Clean'=>'clean'), podcast::specValue('dc_podcast_itunes_explicit')).'</p>'.
  
  '<p class="field"><label for="dc_podcast_itunes_image" class="float"><strong>'.
  __('iTunes image').'&nbsp;:</strong> '.
  helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_itunes_image').'</label>'.
  form::field('dc_podcast_itunes_image'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_itunes_image')).'</p>' .
  
  '<p class="field"><label for="dc_podcast_itunes_new_feed" class="float"><strong>'.
  __('Changing your feed URL').'&nbsp;:</strong> '.
  helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_itunes_new_feed').'</label>'.
  form::field('dc_podcast_itunes_new_feed'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_itunes_new_feed')).'</p>' .
  
  '<p class="field"><label for="dc_podcast_itunes_keywords" class="float"><strong>'.
  __('Keywords').'&nbsp;:</strong> '.
  helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_itunes_keywords').'</label>'.
  form::field('dc_podcast_itunes_keywords'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_itunes_keywords')). '</p>'.
  
  '<fieldset class="options"><legend>iTunes Preview <small>by Seek3r at www.mightyseek.com (english, not as displayed by iTunes)</small></legend>' .
  '<table width="100%" cellspacing="2" cellpadding="5" class="editform" bgcolor="#C5A4E0"><tr valign="top">' .
  '<td>'.$itunes_img.'</td>'.
      '<td><b><font size="+1">'.podcast::specValue('dc_podcast_feed_title').'</font></b><br/>'.trim(eregi_replace( '(^.*\()|(\).*)' , '', podcast::specValue('dc_podcast_feed_editor'))).
  '<br/><br/><br/><br/><br/><font size="-1">Total: x episodes<br/>Category: '.podcast::specValue('dc_podcast_feed_cat_itun').'<br/>Language: English</br></br>'.
  '<p><img src="'.util::getHost().dc_app_url.'/'.DC_ECRIRE.'/tools/'.$dc_podcast_plugin_name.'/itunes-subscribebutton.gif" border="0"/></font></p></td>'.
  '<td><img src="'.util::getHost().dc_app_url.'/'.DC_ECRIRE.'/tools/'.$dc_podcast_plugin_name.'/vert-bar.gif" border="0" width="2" height="300"/>&nbsp;</td>'.
  '<td><b><font size="+1">Podcast Description</font></b><br/><font size="-1">'.str_replace(DC_PODCAST_CR,'<br />',podcast::specValue('dc_podcast_itunes_summary')).'</font>'.
  '</br></br><p><img src="'.util::getHost().dc_app_url.'/'.DC_ECRIRE.'/tools/'.$dc_podcast_plugin_name.'/iTunes_websiteandreportconcern.jpg" border="0"/></p>'. 						
  '</td></tr></table></fieldset>' .
  
'</fieldset>');

buffer::str(
'<fieldset>'.
'<legend>'.__('Item default specifications for').' <em>'.$feed_names[$feed_suffix].'</em> '.'</legend>'.

	'<p class="field"><label for="dc_podcast_item_license" class="float"><strong>'.
	__('Item license').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_item_license').'</label>'.
  form::combo('dc_podcast_item_license'.$feed_suffix, podcast::CreativeCommonsLicenses(), podcast::specValue('dc_podcast_item_license')).'</p>'.

	'<p class="field"><label for="dc_podcast_item_author" class="float"><strong>'.
	__('Items author').'&nbsp;:</strong> '.
	helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_item_author').'</label>'.
	form::field('dc_podcast_item_author'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_item_author')).'</p>'.

'</fieldset>');
/*
buffer::str(
'<fieldset>'.
'<legend>'.__('Item default specifications for').' <em>'.$feed_names[$feed_suffix].'</em> - '.__('iTunes specific').__($itunes_msg).'</legend>'.

	'<p class="field"><label for="dc_podcast_itunes_keywords" class="float"><strong>'.
  __('Keywords').'&nbsp;:</strong> '.
  helpLink('index&amp;plugin='.$dc_podcast_plugin_name,'field dc_podcast_itunes_keywords').'</label>'.
  form::field('dc_podcast_itunes_keywords'.$feed_suffix, 70, 255, podcast::specValue('dc_podcast_itunes_keywords')).
    
  '</p>'.'</fieldset>');
# */
buffer::str(
'<p class="field">' . form::hidden('submited', true) . '</p>' .
'<p class="field">' .
'<input name="' . $mode.'&feed_suffix='.$feed_suffix . '" type="submit" class="submit" value="' . $button_caption . '" />' .

'<p>'.dcNonce::form().'</p>'.
'</form>');
 ?>
