<?php 
# les variables d'dition
$res = ''; # les rsultats de mise  jour des fils RSS
$pod_msg = ''; # les messages  afficher 0#1#2 ...
# gen auto : on actualise systmatiquement le fichier
if (dc_podcast_generate_feeds == 'yes') $getfile = 1;

if (isset($_POST['submited']))
{ # on assigne toutes les variables
	$title = podcast::encode_str($_POST['title']);
	$descf = (empty($_POST['descf'])) ? dc_blog_name :
  	podcast::encode_str( podcast::take( strip_tags( $_POST['descf'] ) , 255) ); 
	$summary = podcast::encode_str( podcast::take( strip_tags( $_POST['summary'] ) , 4000) );
  $author = (empty($_POST['author'])) ? dc_podcast_item_author : podcast::encode_str($_POST['author']);
  $marks = (empty($_POST['marks'])) ? '' : implode(',', $_POST['marks']);
  $status = podcast::encode_str($_POST['status']);
  $url = trim($_POST['url']);
	$comments = (empty($_POST['comments'])) ? '' : trim($_POST['comments']);
  $license = (empty($_POST['license'])) ? dc_podcast_item_license : trim($_POST['license']);
  $license = ( substr($license, 0, strlen(DC_PODCAST_CCL)) == DC_PODCAST_CCL) ? $license : '';
	$length = (empty($_POST['length'])) ? '' : trim($_POST['length']);
	$type = (empty($_POST['type'])) ? '' : trim($_POST['type']);
	$guid = (empty($_POST['guid'])) ? '' : trim($_POST['guid']);
	$post = (empty($_POST['post'])) ? '' : trim($_POST['post']);
  $category = (empty($_POST['category'])) ? '' : podcast::encode_str($_POST['category']);
	$datef = (empty($_POST['datef'])) ? '' : trim($_POST['datef']);
	$duration = (empty($_POST['duration'])) ? '' : trim($_POST['duration']);
	$explicit = (empty($_POST['explicit'])) ? dc_podcast_itunes_explicit : trim($_POST['explicit']);
  $keywords = (empty($_POST['keywords'])) ? dc_podcast_itunes_keywords : podcast::encode_str(strip_multiple_blanks($_POST['keywords']));
  $get_post = false;
  if ($getpost) { # acquisition du billet
  	if ( ($get_post = podcast::checkPostURL($post)) === false )
  		$pod_msg.= '0#'; # __('Unable to bring post') . ' ' . $post;
  }
  if ($getfile) { # acquisition du fichier
  	if ( ($rc = podcast::checkAudioURL($url)) === false )
  		$pod_msg.= '1#'; # __('Unable to bring file') . ' ' . $url;
	}
	# Traitement des erreurs
	# la valeur du champ title est requise pour un affichage correct
	if (trim($title) == '') $title = __('Item') . ' - ' . date('D, j M Y H:i:s O');
  # pas de & dans le nom du fichier
  if ( strpos($url, '&') !== false )
		$pod_msg.= '2#'; # 'Le fichier '.$url.' contient le catactre &amp;. Valider imprativement avec FeedValidator.';
   
  # cration du billet de l'item
	if ( isset($_POST['postit']) ) include dirname(__FILE__).'/createpost.php';
          
  # la date de publication est mise sous forme de timestamp dans la table MySQL
  if ($datef == '') $datef = date('D, j M Y H:i:s O'); # 1.3.8
  $timestamp = strtotime($datef, 0);
  if (!( ($timestamp === false) OR ($timestamp == -1) ))
  	$datef = $timestamp;

	# les champs pour MySQL
	if ($mode == 'add') {
		$sql = 'INSERT INTO '.DB_PREFIX.'podcast (`id`,`title`,`descf`,`summary`,`post`,'.
    '`comments`,`license`,`url`,`length`,`type`,`guid`,`author`,`category`,`datef`,'.
    '`marks`,`status`,`duration`,`explicit`,`keywords`,`user_id`) VALUES (NULL, "' .
    $con->escapeStr($title) . '", "' .
    $con->escapeStr($descf) . '", "' .
    $con->escapeStr($summary) . '", "' .
    $con->escapeStr($post) . '", "' .
    $con->escapeStr($comments) . '", "' .
		$con->escapeStr($license) . '", "' .
    $con->escapeStr($url) . '", "' .
    $con->escapeStr($length) . '", "' .
    $con->escapeStr($type) . '", "' .
    $con->escapeStr($guid) . '", "' .
    $con->escapeStr($author) . '", "' .
    $con->escapeStr($category) . '", "' .
    $con->escapeStr($datef) . '", "' .
    $con->escapeStr($marks) . '", "' .
    $con->escapeStr($status) . '", "' .
    $con->escapeStr($duration) . '", "' .
    $con->escapeStr($explicit) . '", "' .
    $con->escapeStr($keywords) . '", "' .
    $con->escapeStr($_SESSION['sess_user_id']) . '")';
	} else { # mode edit
  	$update_values = '`title`="' . $con->escapeStr($title) . '", ' .
    '`descf`="' . $con->escapeStr($descf) . '", ' .
    '`summary`="' . $con->escapeStr($summary) . '", ' .
    '`author`="' . $con->escapeStr($author) . '", ' .
    '`marks`="' . $con->escapeStr($marks) . '", ' .
    '`status`="' . $con->escapeStr($status) . '", ' .
    '`url`="' . $con->escapeStr($url) . '", ' .
    '`post`="' . $con->escapeStr($post) . '", ' .
    '`comments`="' . $con->escapeStr($comments) . '", ' .
    '`license`="' . $con->escapeStr($license) . '", ' .
    '`guid`="' . $con->escapeStr($guid) . '", ' .
    '`category`="' . $con->escapeStr($category) . '", ' .
    '`datef`="' . $con->escapeStr($datef) . '", ' .
    '`duration`="' . $con->escapeStr($duration) . '", ' .
    '`explicit`="' . $con->escapeStr($explicit) . '", ' .
    '`keywords`="' . $con->escapeStr($keywords) . '", ' .
		'`length`="' . $con->escapeStr($length) . '", ' .
		'`type`="' . $con->escapeStr($type) . '", ' ;

		$sql = 'UPDATE ' . DB_PREFIX . 'podcast SET ' .
				 $update_values .
				 '`user_id`="' . $con->escapeStr($_SESSION['sess_user_id']) . '" ' .
				 'WHERE `id`=' . $_POST['id'];
	}
	if (!$con->execute($sql)) { # si erreur MySQL, msgs
		if ($mode == 'add') {
			$errors[] = __('Error adding an item') . ' (' . $con->error() . ')';
		} else {
			$errors[] = __('Error editing an item') . ' (' . $con->error() . ')';
		}
	} else { # MySQL OK - post-processing dont cration du podcast
		$enr = '&enr=1';
		if (defined('DC_UPDATE_FILE_W') && DC_UPDATE_FILE_W) {
			files::touch(DC_UPDATE_FILE, time());
		}
		# on re-cre le podcast
		if (dc_podcast_generate_feeds == 'yes') {
			if ( ($results = podcast::generate_syndication_feeds()) ) {
				$dc_podcast_feeds = 'yes';
          $res = '&res='.implode(';', $results); # rsultats
			} else {
				$dc_podcast_feeds = 'no';
			}
		} else {
			$dc_podcast_feeds = 'no';
		}
		if ($dc_podcast_feeds != dc_podcast_feeds)
			podcast::updConf('dc_podcast_feeds', $dc_podcast_feeds, '', '', 0);
		if ($mode == 'add') {
			$id_refresh = $con->getLastID();
			if (method_exists($blog,'tiggerLog')) {
        	$blog->tiggerLog('dc_podcast', $id_refresh, 'Add an item');
        } elseif (method_exists($blog,'triggerLog')) {
        	$blog->triggerLog('dc_podcast', $id_refresh, 'Add an item');
        }
		} else {
			$id_refresh = $_POST['id'];
			if (method_exists($blog,'tiggerLog')) {
        	$blog->tiggerLog('dc_podcast', $id_refresh, 'Edit an item');
        } elseif (method_exists($blog,'triggerLog')) {
        	$blog->triggerLog('dc_podcast', $id_refresh, 'Edit an item');
        }
		}
	}
	
	if (count($errors) > 0) {
  	buffer::str(__('Errors'));
  	podcast::DisplayErrors($errors); # on affiche les erreurs et on reste sur la page
		buffer::str('<p class="message"><a href="' . $plugin_url . '&mode=edit' .
      '&id=' . $id_refresh . '">' . __('Back to item') .	'</a></p>');
	} else {
		# pas d'erreurs  afficher, retour  mode edit avec msg enregistrement OK
		# pour affichage du formulaire de l'entre sauvegarde
    if ($pod_msg != '') $pod_msg = '&pod_msg='.trim($pod_msg, ' #');
		header('Location: ' . $plugin_url . '&mode=edit' . '&id=' . $id_refresh .
             $enr . $res . $pod_msg);	# Envoie d'un en-tte HTTP
		exit;
	}
} else { # A podcast has not been submited from the form we display the form for a new or existing MySQL entry
	$mySubMenu->addItem(
  	'<strong>'.__('Back to list').'</strong>',$plugin_url, 'images/ico_retour.png', false);
  if ($path_for_fm != '')
    $mySubMenu->addItem(
    __('Upload'),'tools.php?p=filemanager&amp;f=' . $audio_file_for_fm
    						 ,'images/arrow_up.png',false);

	if ($mode == 'add') {
		buffer::str('<h2>' . __('Add an item') . ' <img src="'.$img_gen_rss.'" alt="check" width="12" height="12" /></h2>');
		$hidden_field = '';
		$url_item = (isset($_GET['url'])) ? $_GET['url'] : '';
		$post_id = (isset($_GET['post_id'])) ? $_GET['post_id'] : '';
		$filename = '';
		$title = '';
		$descf = '';
		$summary = '';
		$post = '';
		$comments = '';
    $license = dc_podcast_item_license;
		$url = $url_item;
		$length = '';
		$type = '';
		$guid = '';
		$author = dc_podcast_item_author;
    $datef = '';
    $marks = '';
    $status = '1';
		$duration = '';
		$explicit = dc_podcast_itunes_explicit;
		$keywords = dc_podcast_itunes_keywords;
		# Podcast It d'un billet
		if ($post_id != '') $rc = checkPostURL($post_id);

	} else { # $mode == 'edit'
		$id = (isset($_GET['id'])) ? $_GET['id'] : '';
    if ( !$expert )
    	$mySubMenu->addItem(
			'<strong>'.__('Expert').'</strong>', $plugin_url . '&amp;mode=expert&amp;id='.$id, 'images/selected.png', false);
		# Affichage titre, infos
    buffer::str('<h2>' . __('Edit the item') . ' <small>- id ' . $id .
      '</small> <img src="'.$img_gen_rss.'" alt="check" width="12" height="12" /></h2>');
    if ( isset($_GET['pod_msg']) ) {
    	$msg_ids = explode('#', $_GET['pod_msg']);
      buffer::str('<span class="message">'.__('Message(s)').'</span><br />');
      foreach ($msg_ids as $msg_id)
      	buffer::str($messages[$msg_id].'<br />' );
    }
		if ( (isset($_GET['enr'])) && ($_GET['enr'] == '1') )
			buffer::str('<span class="message">' . __('Item saved') . '</span> ' . $id);

		$hidden_field = '<p class="field">' . form::hidden('id', $_GET['id']) . '</p>';

		$sql = 'SELECT * FROM `' . DB_PREFIX . 'podcast` WHERE `id`=' . $_GET['id'];
		$rs = $con->select($sql);
		$title = $rs->field('title');
		$descf = $rs->field('descf');
		$summary = $rs->field('summary');
		$post = $rs->field('post');
		$comments = $rs->field('comments');
    $license = $rs->field('license');
		$url = $rs->field('url');
		$length = $rs->field('length');
		$type = $rs->field('type');
		$guid = $rs->field('guid');
		$author = $rs->field('author');
		$category = $rs->field('category');
		$datef = $rs->field('datef');
    if ($datef == '') $datef = date('D, j M Y H:i:s O'); # 1.3.8
    $timestamp = strtotime($datef, 0);
    if ( ($timestamp === false) OR ($timestamp == -1) )
    	$datef = date('D, j M Y H:i:s O', $datef);
    $marks = $rs->field('marks');
    $status = $rs->field('status');
		$duration = $rs->field('duration');
		$explicit = $rs->field('explicit');
    $keywords = $rs->field('keywords');
	}
	# Affichage du formulaire
	# l'affichage est "submited" en mode add ; il est insr dans la table MySQL (nouveau id)
	# et rafffich en dition
	$actu_icon = '<img src="images/ico_goto.png" alt="refresh" width="16" height="16" />';
	if ($mode == 'add') {
		# aprs Ajouter on revient  l'affichage du formulaire d'dition
		$button_caption = '<input name="' . $mode . '" type="submit" class="submit" value="' . __('Add') . '" />';
		$delete_button = '';
		$post_button = '';
		$add_button = '';
		$refresh_file = '';
    if (dc_podcast_generate_feeds == 'yes') {
			$refresh_post = '';
    } else {
    	$refresh_post = '&nbsp;<input name="refreshpost" type="submit" class="submit" value="' . __('Bring the post') . '" />';
    }
	} else { # mode edit
		$button_caption = '<input name="' . $mode . '" type="submit" class="submit" value="' .
		__('Save') . '" />';
		$post_button = '&nbsp;<input name="postit" type="submit" class="submit" value="' . __('Make the post') . '" />';
		$delete_button = '&nbsp;<input name="delete" type="submit" class="submit" value="' .
		__('Delete') . '" onclick="return window.confirm(\'' .
		__('Are you sure you want to delete this item?') . '\')" />';
		$add_button = '';
    $refresh_file = '';
		$refresh_post = '';
    if ($expert) {
      $add_button = '&nbsp;<input name="add" type="submit" class="submit" value="' . __('Copy') . '" />';
      $refresh_file = '&nbsp;<input name="refreshfile" type="submit" class="submit" value="' . __('Bring the file') . '" />';
			$refresh_post = '&nbsp;<input name="refreshpost" type="submit" class="submit" value="' . __('Bring the post') . '" />';
    }
	}
	$readonly = ''; $stts = '';
  if ($status == '0') $stts = '<img alt="check_off (1K)" src="images/check_off.png" height="12" width="12" />';
	if (dc_podcast_generate_feeds == 'yes') $readonly = ''; # 'readonly="readonly"'
	$form_desc = '<fieldset>'.'<legend>'.__('Descriptions') . '</legend>';
	$form_desc.= '<p class="field"><label for="title"><strong>' . __('Title') . '&nbsp;:</strong>&nbsp;' .
		helpLink('index&amp;plugin=podcast', 'field title') . '</label>' .
		form::field('title', 70, 255, $title) . '</p>';
	$form_desc.= '<p class="field"><label for="descf"><strong>' . __('Description') . '&nbsp;:</strong>&nbsp;' .
		helpLink('index&amp;plugin=podcast', 'field descf') . '</label>' .
		form::textArea('descf', 70, 3, $descf) . '</p>';
	$form_desc.= '<p class="field"><label for="summary"><strong>' . __('Informations') . '&nbsp;:</strong>&nbsp;&nbsp;<em>iTunes (' .
		__('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=podcast', 'field summary') . '</label>' .
		form::textArea('summary', 70, 5, $summary) . '</p>';
  if ($expert) {
  	$form_desc.= '<p class="field"><label for="post"><strong>' . __('Description').' (url)' . '&nbsp;:</strong>&nbsp;<em>' .
  		$actu_icon .
  		'(' . __('optional') . ')</em>&nbsp;' .
  		helpLink('index&amp;plugin=podcast', 'field post') . '</label>' .
  		form::field('post', 70, 255, $post) . '</p>';
  	$form_desc.= '<p class="field"><label for="comments"><strong>' . __('Comments').' (url)' . '&nbsp;:</strong>&nbsp;<em>(' .
  		__('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=podcast', 'field comments') . '</label>' .
  		form::field('comments', 70, 255, $comments) . '</p>';
      
    $form_desc.= '<p class="field"><label for="license"><strong>' . __('License').' (url)' . '&nbsp;:</strong>&nbsp;<em>(' .
  		__('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=podcast', 'field license') . '</label>' .
  		form::combo('license', podcast::CreativeCommonsLicenses(), $license) . '</p>';
  }
	$form_desc.= '<p class="field"><label for="author"><strong>' . __('Author') . '&nbsp;:</strong>&nbsp;&nbsp;<em>(' .
		__('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=podcast', 'field author') . '</label>' .
		form::field('author', 70, 255, $author) . '</p>';
    if ($expert) {
	$form_desc.= '<p class="field"><label for="category"><strong>' . __('Categories') . '&nbsp;:</strong>&nbsp;&nbsp;<em>(' .
		__('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=podcast', 'field category') . '</label>' .
		form::field('category', 70, 255, $category) . '</p>' .

    '<p class="field"><label for="datef"><strong>' . __('Date') . '&nbsp;:</strong>&nbsp;' .
			helpLink('index&amp;plugin=podcast', 'field datef') . '</label>' .
			form::field('datef', 40, 40, $datef) . '</p>';
    }
    if (count($feed_names) > 1) { # il y a des fils RSS spcifiques
      $form_desc.= '<p class="field"><label for="marks"><strong>'.
      __('Publish the item in one or more specific feeds').'&nbsp;&nbsp;:</strong><em>&nbsp;&nbsp;(' .
  		__('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=podcast', 'field marks').'&nbsp;&nbsp;'.'</label>';
# $form_desc.= 'Slection en cours : <strong>'.$marks.'</strong> ; sur les fils spcifiques : '.'<em>'.trim(substr(dc_podcast_feed_tags, strpos(dc_podcast_feed_tags, ','))," ,").'</em><br />'."\n";
			$array_marks = array_flip( explode(',', $marks) );
      foreach (array_slice($feed_names, 1) as $key => $value) {
        $form_desc.= '<input type="checkbox" name="marks[]" value="'.$value.'" '.
        	( ( array_key_exists($value, $array_marks) === true ) ? 'checked="checked"' : '').'/><strong>'.
          constant('dc_podcast_feed_title'.$key).'</strong> : '.
          $value.' - <em>'.substr($key, 1).'.'.dc_podcast_feed_ext.'</em><br />'."\n";
      }
      $form_desc.= '</p>';
    }
    $form_desc.= '<p class="field"><label for="status"><strong>' . __('Status') . '&nbsp;:</strong>&nbsp;' .
    		$stts . '&nbsp;' .
		helpLink('index&amp;plugin=podcast', 'field status') . '</label>' .
		form::combo('status',array(__('Online')=>1,__('Offline')=>0), $status).'</p>';
	$form_desc.= '</fieldset>';

	$form_flux = '<fieldset>'.
		'<legend>'.__('Audio, video, doc file') . '</legend>';
	$form_flux.= '<p class="field"><label for="url"><strong>' . __('Audio, video, doc file') . '&nbsp;:</strong>&nbsp;' .
		$actu_icon . ' ' .
			helpLink('index&amp;plugin=podcast', 'field url') . '</label>' .
			form::field('url', 70, 255, $url) . '</p>';
    if ($expert) {
		$form_flux.= '<p class="field"><label for="length"><strong>' . __('Length') . '&nbsp;:</strong>&nbsp;' .
			helpLink('index&amp;plugin=podcast', 'field length') . '</label>' .
			form::field('length', 40, 40, $length, '', $readonly) . '</p>' .
		'<p class="field"><label for="type"><strong>' . __('Type') . '&nbsp;:</strong>&nbsp;' .
			helpLink('index&amp;plugin=podcast', 'field type') . '</label>' .
			form::field('type', 40, 40, $type, '', $readonly) . '</p>';
	# fin champs en lecture seulement
	$form_flux.= '<p class="field"><label for="guid"><strong>' . __('guid') . '&nbsp;:</strong>&nbsp;' .
			helpLink('index&amp;plugin=podcast', 'field guid') . '</label>' .
			form::field('guid', 70, 255, $guid) . '</p>';
    }
	$form_flux.= '</fieldset>';

	$form_itunes = '';
	if ($expert) {
	$form_itunes.= '<fieldset>'.
		'<legend>'.__('iTunes specific') . '</legend>' .
		'<p class="field"><label for="duration"><strong>' . __('Duration') . '&nbsp;:</strong>&nbsp;&nbsp;<em>(' .
			__('optional') . ')</em>&nbsp;' .
			helpLink('index&amp;plugin=podcast', 'field duration') . '</label>' .
			form::field('duration', 8, 8, $duration) . '</p>' .
		'<p class="field"><label for="explicit"><strong>' . __('Explicit') . '&nbsp;:</strong>&nbsp;&nbsp;<em>(' .
			__('optional') . ')</em>&nbsp;' .
			helpLink('index&amp;plugin=podcast', 'field explicit') . '</label>' .
			form::combo('explicit',array(__('Yes')=>'yes',__('No')=>'no','Clean'=>'clean'), $explicit).'</p>' .
      '<p class="field"><label for="keywords"><strong>' . __('Keywords') . '&nbsp;:</strong>&nbsp;&nbsp;<em>(' .
		__('optional') . ')</em>&nbsp;' . helpLink('index&amp;plugin=podcast', 'field keywords') . '</label>' .
		form::field('keywords', 70, 255, $keywords) . '</p>';
	$form_itunes.= '</fieldset>';
	}
	buffer::str(
		# le test de retour est fait sur la variable $_POST, edit delete post ...
		'<form action="' . $plugin_url . '" method="post">' .
		$form_desc .
		$form_flux .
		$form_itunes .
		$hidden_field .
		'<p class="field">' .
		form::hidden('submited', true) .
		$button_caption .
		$post_button .
		$delete_button .
		$add_button .
		$refresh_file .
		$refresh_post .
		
		'</p>' .
		'<p>'.dcNonce::form().'</p>'. 
		'</form>'
	);
	$msg_gen = '';
	if (dc_podcast_generate_feeds == 'yes') {
		$msg_gen.= __('The podcast will be updated.');
	} else {
		$msg_gen.= ' ' . __('The podcast will <strong>not</strong> be modified.');
	}
	buffer::str($msg_gen);
	if ( isset($_GET['res']) ) {
    buffer::str('<br /><br /><span class="message">'.__('Message(s)').'</span>');
  	podcast::DisplayResults(explode(';', $_GET['res']), 'edit');
  }
}
 ?>
