<?php 
# Sous menu
$mySubMenu->addItem(
	'<strong>'.__('Add').'</strong>', $plugin_url . '&amp;mode=add', 'images/ico_edit.png', false);
$mySubMenu->addItem(
	'<strong>'.__('Gen RSS').'</strong>', $plugin_url . '&amp;mode=gen&amp;select=0', $img_gen_rss, false);
$mySubMenu->addItem(
	'<strong>'.__('Config').'</strong>',$plugin_url . '&amp;mode=conf', 'images/ico_edit.png', false);
# Lecture des entres pour la page
$sql = 'SELECT COUNT(*) AS `nb_podcasts` FROM `' . DB_PREFIX . 'podcast`';
$rs = $con->select($sql);
$nb_podcasts = $rs->field('nb_podcasts');
$max_pages = ceil($nb_podcasts / dc_podcast_displayed_items_per_page);
$env = (!empty($_GET['env']) && $_GET['env'] <= $max_pages) ? $_GET['env'] : 1;

$sql = 'SELECT * FROM `' . DB_PREFIX . 'podcast` ORDER BY `datef` DESC LIMIT ' . (($env - 1) * dc_podcast_displayed_items_per_page) . ',' . dc_podcast_displayed_items_per_page;
$rs = $con->select($sql);
if (dc_podcast_displayed_items_per_page == '') $dc_podcast_displayed_items_per_page = '20';
# la fonction podcast_line dans functions.php affiche une entre dans la liste
$lum = new multipage($env, 'podcast_line', $rs->getData(), $nb_podcasts, dc_podcast_displayed_items_per_page);
$lum->setOption('html_links', '<p>' . __('Page(s)') . ' : %s</p>');
$lum->setOption('html_prev', '&lt;' . __('prev. page'));
$lum->setOption('html_next', __('next page') . '&gt;');
$lum->setOption('html_empty', '<p><strong>' . __('No items') . '</strong></p>');

# JavaScript
$js_openCloseAll = $h_script = '';
$data = $rs->getData();
if (!empty($data)) {
	$ids = array();
	foreach($data as $data_key => $data_value) {
		$ids[] = 'podcast' . $data_value['id'];
	}
	$h_script =
	'<script type="text/javascript">' . "\n" .
	"js_ids = new Array('" . implode("','" , $ids) . "');\n" .
	"window.onload = function() { mOpenClose(js_ids, -1); }\n" .
	"</script>\n";

	$js_openCloseAll =
	'<p class="small"><a href="#" onclick="mOpenClose(js_ids, 1)">' . __('show all') . '</a> - ' .
	'<a href="#" onclick="mOpenClose(js_ids, -1)">' . __('hide all') . '</a></p>';
}
# Titre de la page
buffer::str('<h2>Podcast <small>- ' . $nb_podcasts . ' items' . '</small> ' .
'<img src="' . $img_gen_rss . '" alt="check" width="12" height="12" /></h2>');
if (isset($_GET['fn']))
	buffer::str('<div class="message"><p>' . $_GET['fn'] . ' ' . __('created') . ' - ' . $_GET['n'] . ' items</p></div>');
$id = (isset($_GET['id'])) ? $_GET['id'] : '';
if ( (isset($_GET['del'])) && ($_GET['del'] == '1') )
	buffer::str('<div class="message"><p>' . __('Item deleted') . ' <small>- id ' . $id . '</small></p></div>');
if ( (isset($_GET['del'])) && ($_GET['del'] == '0') )
	buffer::str('<div class="erreur"><p><strong>' . __('Error(s)') . ' :</strong></p>' . __('Item not deleted') . ' <small>' . $id . '</small></div>');

buffer::str($lum->getLinks());
buffer::str($h_script);
buffer::str($js_openCloseAll);
buffer::str($lum->getPage());
buffer::str($lum->getLinks());
# message d'accueil
if ( ($nb_podcasts == 0) AND (@file_exists(DC_PODCAST_ROOT . 'accueil.html')) ) {
	$msg = file_get_contents(DC_PODCAST_ROOT . 'accueil.html');
	$msg.= '<p><em>Afficher la</em> <strong>Doc</strong> <em>pour revoir ce mode d\'emploi et ses astuces</em>.</p>';
    if (dc_encoding == 'UTF-8') $msg = utf8_encode($msg);
	buffer::str($msg);
}
 ?>